//+------------------------------------------------------------------+
//|                                           BillWilliamsSystem.mqh |
//|                      Copyright 2015, ForexInside AlgoTrading Lab |
//|                                            http://forexinside.me |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, ForexInside AlgoTrading Lab"
#property link      "http://forexinside.me"
#property version   "1.0"

input string Block1="=== Analyzer ===";
input int AnalyzerBarCount=300;
input bool AnalyzerShowSignals=true;
input bool AnalyzerShowAllSignals=false;
input string Block2="=== Alligator ===";
input bool AlligatorShow=true;
input int AlligatorJawPeriod= 13;
input int AlligatorJawShift = 8;
input int AlligatorTeethPeriod= 8;
input int AlligatorTeethShift = 5;
input int AlligatorLipsPeriod = 5;
input int AlligatorLipsShift=3;
input ENUM_MA_METHOD AlligatorMAMethod=MODE_SMMA;
input ENUM_APPLIED_PRICE AlligatorAppliedPrice=PRICE_MEDIAN;
input string Block3="=== Fractal [Dimension 1] ===";
input bool FractalShow=true;
input bool FractalEnableTrade=true;
input string Block4="=== AO [Dimension 2] ===";
input bool AOShow=true;
input bool AOEnableTrade=true;
input string Block5="=== AC [Dimension 3] ===";
input bool ACShow=true;
input bool ACEnableTrade=true;
input string Block6= "=== Zone [Dimension 4] ===";
input bool ZoneShow=true;
input bool ZoneEnableTrade=true;
input string Block7="=== Balance Line [Dimension 5] ===";
input bool BalanceLineShow=true;
input bool BalanceLineEnableTrade=true;
input string Block8="=== Trade ===";
input double TradeLot=0.1;
input string Block9="=== View ===";
input color ViewColor=clrBlue;

#include <ForexInside\BillWilliamsPanel.mqh>

CBillWilliamsDialog *dlg=NULL;
CBillWilliamsTS *ts=NULL;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   int x0=10;
   int y0=10;
//---
   bool isTester=MQLInfoInteger(MQL_TESTER);
   if(!isTester)
     {
      dlg=new CBillWilliamsDialog(BillWilliamsParamsFromInput());
      if(!dlg.Create(0,"BillWilliams Trade System Panel",0,x0,y0,x0+BILLWILLIAMS_DIALOG_WIDTH,y0+BILLWILLIAMS_DIALOG_HEIGHT)) return INIT_FAILED;
      dlg.Run();
     }
   CreateBillWilliamsTS();
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if(ts!=NULL)
     {
      delete ts;
     }
   if(dlg!=NULL)
     {
      dlg.Destroy(reason);
      delete dlg;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateBillWilliamsTS()
  {
   if(ts!=NULL) delete ts;
   if(dlg!=NULL) ts= new CBillWilliamsTS(dlg.GetParams());
   else ts= new CBillWilliamsTS(BillWilliamsParamsFromInput());
//---
   ts.ProcessTick();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
TBillWilliamsTSParams BillWilliamsParamsFromInput()
  {
   TBillWilliamsTSParams params;
   params.AnalyzerBarCount=AnalyzerBarCount;
   params.AnalyzerShowSignals=AnalyzerShowSignals;
   params.AnalyzerShowAllSignals=AnalyzerShowAllSignals;
   params.AlligatorShow=AlligatorShow;
   params.AlligatorJawPeriod=AlligatorJawPeriod;
   params.AlligatorJawShift=AlligatorJawShift;
   params.AlligatorTeethPeriod=AlligatorTeethPeriod;
   params.AlligatorTeethShift=AlligatorTeethShift;
   params.AlligatorLipsPeriod=AlligatorLipsPeriod;
   params.AlligatorLipsShift=AlligatorLipsShift;
   params.AlligatorMAMethod=AlligatorMAMethod;
   params.AlligatorAppliedPrice=AlligatorAppliedPrice;
   params.FractalShow=FractalShow;
   params.FractalEnableTrade=FractalEnableTrade;
   params.AOShow=AOShow;
   params.AOEnableTrade=AOEnableTrade;
   params.ACShow=ACShow;
   params.ACEnableTrade=ACEnableTrade;
   params.ZoneShow=ZoneShow;
   params.ZoneEnableTrade= ZoneEnableTrade;
   params.BalanceLineShow=BalanceLineShow;
   params.BalanceLineEnableTrade=BalanceLineEnableTrade;
   params.TradeLot=TradeLot;
   params.ViewColor=ViewColor;
   return params;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_CUSTOM+100)
     {
      CreateBillWilliamsTS();
      return;
     }
   if(dlg!=NULL) dlg.ChartEvent(id,lparam,dparam,sparam);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(ts!=NULL) ts.ProcessTick();
  }
//+------------------------------------------------------------------+
